<?php

include __DIR__ . '/helpers.php';

// Секретный ключ канала
$channelSecret = 'f2d7f8704eff95087ed45b23ba99c0b5aac8278e';
// Scope ID, который был получен при подключении канала в аккаунт
$scopeId = '344a5002-f8ca-454d-af3d-396180102ac7_52e591f7-c98f-4255-8495-827210138c81';
// Тело запроса
$requestBody = [
    'conversation_id' => 'my_int-8e3e7640-49af-4448-a2c6-d5a421f7f217',
    'source' => [
        'external_id' => '78001234567', // external_id источника в API Источников, поле не передается, если интеграция не поддерживает множественные источники
    ],
    'user' => [
        'id' => 'my_int-1376265f-86df-4c49-a0c3-a4816df41af9',
        'avatar' => 'https://example.com/users/avatar.png',
        'name' => 'Имя клиента',
        'profile' => [
            'phone' => '+79151112233',
            'email' => 'example.client@example.com',
        ],
        'profile_link' => 'https://example.com/profile/example.client',
    ]
];
$jsonBody = json_encode($requestBody);
$checkSum = createBodyChecksum($jsonBody);
$apiMethod = sprintf('/v2/origin/custom/%s/chats', $scopeId);

// Составим подпись
$signature = createSignature(
    $channelSecret,
    $checkSum,
    $apiMethod
);

// Подготовим заголовки
$curlHeaders = prepareHeaderForCurl($checkSum, $signature);

echo 'POST ' . $apiMethod . PHP_EOL;
foreach ($curlHeaders as $header) {
    echo $header . PHP_EOL;
}
echo PHP_EOL . $jsonBody . PHP_EOL . PHP_EOL;

// Выполним запрос
execCurl($apiMethod, $jsonBody, $curlHeaders);
