<?php

include __DIR__ . '/helpers.php';

// Секретный ключ канала
$channelSecret = 'f2d7f8704eff95087ed45b23ba99c0b5aac8278e';
// Scope ID, который был получен при подключении канала в аккаунт
$scopeId = '344a5002-f8ca-454d-af3d-396180102ac7_52e591f7-c98f-4255-8495-827210138c81';

// Тело запроса, отправим сообщение в amoCRM в тихом режиме, которое менеджер написал клиенту, но мы можем точно идентифицировать менеджера
$requestBody = [
    'event_type' => 'new_message',
    'payload' => [
        'timestamp' => time(),
        'msec_timestamp' => round(microtime(true) * 1000),
        'msgid' => 'my_int-5f2836a8ca476',
        'conversation_id' => 'my_int-d5a421f7f217',
        'sender' => [
            'ref_id' => '76fc2bea-902f-425c-9a3d-dcdac4766090',
        ],
        'receiver' => [
            'id' => 'my_int-1376265f-86df-4c49-a0c3-a4816df41af8',
            'avatar' => 'https://example.com/users/avatar.png',
            'name' => 'Вася клиент',
            'profile' => [
                'phone' => '+79151112233',
                'email' => 'example.client@example.com',
            ],
            'profile_link' => 'https://example.com/profile/example.client',
        ],
        'message' => [
            'type' => 'text',
            'text' => 'Сообщение от менеджера 76fc2bea-902f-425c-9a3d-dcdac4766090',
        ],
        'silent' => true,
    ],
];


// Тело запроса, отправим сообщение в amoCRM в тихом режиме, которое менеджер написал клиенту, но мы не можем идентифицировать менеджера
$requestBody = [
    'event_type' => 'new_message',
    'payload' => [
        'timestamp' => time(),
        'msec_timestamp' => round(microtime(true) * 1000),
        'msgid' => 'my_int-5f2836a8ca477',
        'conversation_id' => 'my_int-d5a421f7f217',
        'sender' => [
            'id' => 'my_int-bot_user_id',
            'name' => 'Bot',
            'ref_id' => 'f1910c7f-b1e0-4184-bd09-c7def2a9109a',
        ],
        'receiver' => [
            'id' => 'my_int-1376265f-86df-4c49-a0c3-a4816df41af8',
            'avatar' => 'https://example.com/users/avatar.png',
            'name' => 'Вася клиент',
            'profile' => [
                'phone' => '+79151112233',
                'email' => 'example.client@example.com',
            ],
            'profile_link' => 'https://example.com/profile/example.client',
        ],
        'message' => [
            'type' => 'text',
            'text' => 'Сообщение от менеджера 76fc2bea-902f-425c-9a3d-dcdac4766090',
        ],
        'silent' => true,
    ],
];

// Тело запроса, отправим сообщение в amoCRM в тихом режиме, которое написал нам клиент
$requestBody = [
    'event_type' => 'new_message',
    'payload' => [
        'timestamp' => time(),
        'msec_timestamp' => round(microtime(true) * 1000),
        'msgid' => 'my_int-5f2836a8ca481',
        'conversation_id' => 'my_int-d5a421f7f218',
        'sender' => [
            'id' => 'my_int-1376265f-86df-4c49-a0c3-a4816df41af8',
            'avatar' => 'https://images.pexels.com/photos/10050979/pexels-photo-10050979.jpeg?auto=compress&cs=tinysrgb&dpr=2&w=500',
            'profile' => [
                'phone' => '+79151112233',
                'email' => 'example.client@example.com',
            ],
            'profile_link' => 'https://example.com/profile/example.client',
            'name' => 'Вася клиент',
        ],
        'message' => [
            'type' => 'text',
            'text' => 'Сообщение от клиента',
        ],
        'silent' => true,
    ],
];
$jsonBody = json_encode($requestBody);
$checkSum = createBodyChecksum($jsonBody);
$apiMethod = sprintf('/v2/origin/custom/%s', $scopeId);

// Составим подпись
$signature = createSignature(
    $channelSecret,
    $checkSum,
    $apiMethod
);

// Подготовим заголовки
$curlHeaders = prepareHeaderForCurl($checkSum, $signature);

echo 'POST ' . $apiMethod . PHP_EOL;
foreach ($curlHeaders as $header) {
    echo $header . PHP_EOL;
}
echo PHP_EOL . $jsonBody . PHP_EOL . PHP_EOL;

// Выполним запрос
execCurl($apiMethod, $jsonBody, $curlHeaders);
