<?php

include __DIR__ . '/helpers.php';

// Определим методы, которые выполняют бизнес-логику
function saveTextMessage(
    string $messageReceiver,
    string $chatId,
    string $text
) {
    // Сохраняем текстовое сообщение
}

function savePictureMessage(
    string $messageReceiver,
    string $chatId,
    array $file,
    string $messageText
) {
    // Сохраняем изображение
}

function saveFileMessage(
    string $messageReceiver,
    string $chatId,
    array $file,
    string $messageText
) {
    // Сохраняем файл
}

function downloadFile(string $url): array
{
    // сохраняем файл по ссылке на диск, возвращаем информацию о файле
    return [];
}

function setErrorDeliveryStatus($messageId) {
    //Обновляем статус доставки сообщения с информацией, что оно не обработано
}


// Секретный ключ канала
$channelSecret = 'f2d7f8704eff95087ed45b23ba99c0b5aac8278e';

if ($_SERVER ['REQUEST_METHOD'] !== 'POST') {
    throw new RuntimeException('Unsupported request');
}

//Полученное тело запроса
$str = file_get_contents('php://input');
$body = stream_get_contents(STDIN);
if (empty($body)) {
    throw new RuntimeException('Empty body');
}
$signature = hash_hmac('sha1', $str, $channelSecret);

// Проверяем подпись
if (!isset($_SERVER['HTTP_X_SIGNATURE']) || $signature !== $_SERVER['HTTP_X_SIGNATURE']) {
    echo 'Invalid hook';
    die;
}

$hookBody = json_decode($body, true);
if (!$hookBody) {
    throw new RuntimeException('Unsupported body');
}

// ID аккаунта в API чатов
$accountId = $hookBody['account_id'];

// ID сообщения в API чатов
$messageId = $hookBody['message']['message']['id'];
// Тип сообщения
$messageType = $hookBody['message']['message']['type'];
// Тип сообщения
$messageText = $hookBody['message']['message']['text'];
// ID чата, в которое было отправлено сообщение на стороне интеграции
$messageChatId = $hookBody['message']['conversation']['client_id'];
// ID чата, в которое было отправлено сообщение на стороне amoCRM
$messageAmoCrmChatId = $hookBody['message']['conversation']['id'];
// Ссылка на прикрепленный к сообщению файл
$fileLink = $hookBody['message']['message']['media'] ?? null;
// ID получателя на стороне интеграции
$receiverId = $hookBody['message']['receiver']['id'];

switch ($hookBody['message']['message']['type']) {
    case 'text':
        saveTextMessage(
            $receiverId,
            $messageChatId,
            $messageText
        );
        break;
    case 'picture':
        $downloadedFile = downloadFile($fileLink);
        savePictureMessage(
            $receiverId,
            $messageChatId,
            $downloadedFile,
            $messageText
        );
        break;
    case 'file':
        $downloadedFile = downloadFile($fileLink);
        saveFileMessage(
            $receiverId,
            $messageChatId,
            $downloadedFile,
            $messageText
        );
        break;
    default:
        setErrorDeliveryStatus($messageId);
        throw new RuntimeException('Unsupported message type');
        break;
}

